﻿@page "/matches/create"

@using Models.MatchData
@using Models.SeasonData
@using Models.CompetitionData
@using Models.RoundData
@using Models.StadiumData
@using Business.Repository.IRepository
@inject NavigationManager NavigationManager
@inject IJSRuntime JsRuntime
@inject IMatchCoreRepository MatchCoreRepository
@inject IMatchFutsalRepository MatchFutsalRepository
@inject IMatchBasketballRepository MatchBasketballRepository
@inject ICompetitionParentRepository CompetitionParentRepository
@inject ICompetitionRepository CompetitionRepository
@inject ICompetitionTeamRepository CompetitionTeamRepository
@inject IStadiumRepository StadiumRepository
@inject IRefereeMatchRepository RefereeMatchRepository
@inject IRoundRepository RoundRepository

@inject Blazored.LocalStorage.ILocalStorageService localStorage

<div class="row mt-2 mb-5">
    <h3 class="card-title text-info mb-3 ml-3">Create Match - Season: @CurrentSeason</h3>
    <EditForm Model="@MatchCoreModel" OnValidSubmit="HandleCreateUpdate">
        <DataAnnotationsValidator />
        @*<ValidationSummary />*@
        <div class="form-row">
            <div class="col-4">
                <label>League:</label>
                <select class="form-control" @bind="selectedLeagueId">
                    @if (Leagues != null)
                    {
                        <option value="0">-----</option>
                        @foreach (var league in Leagues)
                        {
                            <option value="@league.Id">@league.Name</option>
                        }
                    }
                </select>
            </div>
            @if (selectedLeagueId != 0)
            {
                <div class="col-4">
                    <label>Competition:</label>
                    <select class="form-control" @bind="SelectedCompetitionId">
                        @if (Competitions != null)
                        {
                            <option value="0">-----</option>
                            @foreach (var competition in Competitions.Where(x => x.CompetitionParentId == selectedLeagueId))
                            {
                                <option value="@competition.Id">@competition.Name</option>
                            }
                        }
                    </select>
                </div>
            }
            else
            {
                selectedRoundId = 0;
            }
            @if (SelectedCompetitionId != 0 && selectedLeagueId != 0)
            {
                <div class="col">
                    <label>Round:</label>
                    <select class="form-control" @bind="selectedRoundId">
                        <option value="0">-----</option>
                        @if (Rounds != null)
                        {
                            @foreach (var round in Rounds.Where(x => x.CompetitionId == SelectedCompetitionId))
                            {
                                <option value="@round.Id">@round.Name</option>
                            }
                        }
                    </select>
                </div>
            }
        </div>
        <div class="form-row">
            <div class="col-6">
                <label>Home team:</label>
                <select class="form-control" @bind="selectedHomeTeamId">
                    <option value="0">-----</option>
                    @if (SelectedCompetitionId != 0)
                    {
                        @foreach (var team in CompTeamsForSelect)
                        {
                            @if (team.TeamId != selectedAwayTeamId)
                            {
                                <option value="@team.TeamId">@team.Team.Name</option>
                            }
                        }
                    }
                </select>
            </div>
            <div class="col-6">
                <label>Away team:</label>
                <select class="form-control" @bind="selectedAwayTeamId">
                    <option value="0">-----</option>
                    @if (SelectedCompetitionId != 0)
                    {
                        @foreach (var team in CompTeamsForSelect)
                            @if (team.TeamId != selectedHomeTeamId)
                            {
                                <option value="@team.TeamId">@team.Team.Name</option>
                            }
                        }
                </select>
            </div>
        </div>
        <div class="form-row">
            <div class="col-2">
                <label>Date & Time:</label>
                <input class="form-control" type="date" @bind="Datee">
                <input class="form-control" type="time" @bind="Time">
            </div>
            <div class="col-4">
                <label>Stadium:</label>
                <select class="form-control" @bind="selectedStadiumId">
                    <option value="0">-----</option>
                    @foreach (var stadium in Stadiums)
                    {
                        <option value="@stadium.Id">@stadium.Name</option>
                    }
                </select>
            </div>
        </div>
        <div class="form-group mt-3">
            <button class="btn btn-primary">Create Match</button>
        </div>
    </EditForm>
</div>

@code {

    private MatchCoreDTO MatchCoreModel { get; set; } = new MatchCoreDTO();
    private MatchFutsalDTO MatchFutsalModel { get; set; } = new MatchFutsalDTO();
    private MatchBasketballDTO MatchBasketballModel { get; set; } = new MatchBasketballDTO();
    private IEnumerable<CompetitionParentDTO> Leagues { get; set; } = new List<CompetitionParentDTO>();
    private IEnumerable<CompetitionDTO> Competitions { get; set; } = new List<CompetitionDTO>();
    private IEnumerable<CompetitionDTO> CompetitionsForSelect { get; set; } = new List<CompetitionDTO>();
    private IEnumerable<CompetitionTeamDTO> CompTeamsForSelect { get; set; } = new List<CompetitionTeamDTO>();
    private IEnumerable<StadiumDTO> Stadiums { get; set; } = new List<StadiumDTO>();
    private IEnumerable<RoundDTO> Rounds { get; set; } = new List<RoundDTO>();

    private string CurrentSeason { get; set; }
    private string CurrentSport { get; set; }
    private int matchId { get; set; }
    public DateTime Datee = new DateTime(2021, 02, 01);
    public DateTime Time = new DateTime(2021, 01, 01, 12, 0, 0);
    private int selectedLeagueId { get; set; }
    private int selectedHomeTeamId { get; set; }
    private int selectedAwayTeamId { get; set; }
    private int selectedStadiumId { get; set; }
    private int _selectedCompetitionId = 0;
    private int SelectedCompetitionId
    {
        get
        {
            return _selectedCompetitionId;
        }
        set
        {
            _selectedCompetitionId = value;
            HandleSelectCompetitionChange(value);
        }
    }
    private int selectedRoundId { get; set; }
    protected override async Task OnInitializedAsync()
    {

        //create
        CurrentSeason = await localStorage.GetItemAsync<string>("seasonName");
        CurrentSport = await localStorage.GetItemAsync<string>("sportName");
        Leagues = await CompetitionParentRepository
            .GetAllFromSeason(await localStorage.GetItemAsync<int>("seasonId"));

        Competitions = await CompetitionRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
        Rounds = await RoundRepository.GetAllFromSport(await localStorage.GetItemAsync<int>("sportId"));
        Stadiums = await StadiumRepository.GetAll();


        //var result = await MatchCoreRepository.Create(MatchCoreModel);

    }
    private async Task HandleCreateUpdate()
    {
        try
        {
            MatchCoreModel.CompetitionId = SelectedCompetitionId;
            MatchCoreModel.TeamAwayId = selectedAwayTeamId;
            MatchCoreModel.TeamHomeId = selectedHomeTeamId;
            MatchCoreModel.StadiumId = selectedStadiumId;
            MatchCoreModel.RoundId = selectedRoundId;
            MatchCoreModel.Date = new DateTime(Datee.Year, Datee.Month, Datee.Day, Time.Hour, Time.Minute, Time.Second);

            int result = DateTime.Compare(Datee, DateTime.Now);

            if (result < 0)
            {
                MatchCoreModel.MatchStatusId = 3; // finished 
            }
            else
            {
                MatchCoreModel.MatchStatusId = 2; //scheduled -> live will be only when timer is started
            }
            var matchId = MatchCoreRepository.Create(MatchCoreModel);

            if (CurrentSport == "Futsal")
            {
                MatchFutsalModel.MatchId = matchId;
                var createResultMatchFutsal = await MatchFutsalRepository.Create(MatchFutsalModel);
            }
            else if (CurrentSport == "Basketball")
            {
                MatchBasketballModel.MatchId = matchId;
                var createResultMatchBasketball = await MatchBasketballRepository.Create(MatchBasketballModel);
            }

            //create

            await JsRuntime.ToastrSuccess("Match created successfully");
            await Task.Delay(300);
            NavigationManager.NavigateTo("/matches/" + CurrentSport + "/" + matchId, true);

        }
        catch (Exception ex)
        {
            throw ex;
        }


    }
    private async void HandleSelectCompetitionChange(int competitionId)
    {
        CompTeamsForSelect = await CompetitionTeamRepository.GetAllFromCompetition(_selectedCompetitionId);
    }
}